test-all.sh 15.8 KB
Newer Older
sangshuduo's avatar
sangshuduo 已提交
1 2
#!/bin/bash

3 4 5 6 7 8
# Color setting
RED='\033[0;31m'
GREEN='\033[1;32m'
GREEN_DARK='\033[0;32m'
GREEN_UNDERLINE='\033[4;32m'
NC='\033[0m'
L
liuyq-617 已提交
9

10 11 12
tests_dir=`pwd`
IN_TDINTERNAL="community"

P
Ping Xiao 已提交
13 14
function stopTaosd {
	echo "Stop taosd"
P
Ping Xiao 已提交
15
  sudo systemctl stop taosd
P
Ping Xiao 已提交
16 17 18 19 20 21 22 23 24
  PID=`ps -ef|grep -w taosd | grep -v grep | awk '{print $2}'`
	while [ -n "$PID" ]
	do
    pkill -TERM -x taosd
    sleep 1
  	PID=`ps -ef|grep -w taosd | grep -v grep | awk '{print $2}'`
	done
}

L
liuyq-617 已提交
25 26
function dohavecore(){
  corefile=`find $corepath -mmin 1`  
L
liuyq-617 已提交
27
  core_file=`echo $corefile|cut -d " " -f2`
L
liuyq-617 已提交
28
  proc=`echo $corefile|cut -d "_" -f3`
L
liuyq-617 已提交
29
  if [ -n "$corefile" ];then
30
    echo 'taosd or taos has generated core'
L
liuyq-617 已提交
31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49
    if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]] && [[ $1 == 1 ]]; then
      cd ../../../
      tar -zcPf $corepath'taos_'`date "+%Y_%m_%d_%H_%M_%S"`.tar.gz debug/build/bin/taosd debug/build/bin/tsim debug/build/lib/libtaos*so*
      if [[ $2 == 1 ]];then
        cp -r sim ~/sim_`date "+%Y_%m_%d_%H:%M:%S"`
        rm -rf sim/case.log
      else
        cd community
        cp -r sim ~/sim_`date "+%Y_%m_%d_%H:%M:%S" `
        rm -rf sim/case.log
      fi
    else 
      cd ../../
      if [[ $1 == 1 ]];then 
        tar -zcPf $corepath'taos_'`date "+%Y_%m_%d_%H_%M_%S"`.tar.gz debug/build/bin/taosd debug/build/bin/tsim debug/build/lib/libtaos*so*
        cp -r sim ~/sim_`date "+%Y_%m_%d_%H:%M:%S" `
        rm -rf sim/case.log
      fi
    fi
50
    if [[ $1 == 1 ]];then
L
liuyq-617 已提交
51
      echo '\n'|gdb /usr/local/taos/bin/$proc $core_file -ex "bt 10" -ex quit
52 53
      exit 8
    fi
L
liuyq-617 已提交
54
  fi
55
}
L
liuyq-617 已提交
56

57 58
function runSimCaseOneByOne {
  while read -r line; do
P
Ping Xiao 已提交
59
    if [[ $line =~ ^./test.sh* ]] || [[ $line =~ ^run* ]]; then
60
			case=`echo $line | grep sim$ |awk '{print $NF}'`    
P
Ping Xiao 已提交
61
      start_time=`date +%s`      
P
Ping Xiao 已提交
62
      date +%F\ %T | tee -a out.log
L
liuyq-617 已提交
63 64 65
      if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
        echo -n $case
        ./test.sh -f $case > /dev/null 2>&1 && \
L
liuyq-617 已提交
66
        ( grep -q 'script.*'$case'.*failed.*, err.*lineNum' ../../../sim/tsim/log/taoslog0.0 && echo -e "${RED} failed${NC}" | tee -a out.log  ||  echo -e "${GREEN} success${NC}" | tee -a out.log )|| \
L
liuyq-617 已提交
67 68 69 70 71
        ( grep -q 'script.*success.*m$' ../../../sim/tsim/log/taoslog0.0 && echo -e "${GREEN} success${NC}" | tee -a out.log )  || \
        echo -e "${RED} failed${NC}" | tee -a out.log
      else
        echo -n $case
        ./test.sh -f $case > /dev/null 2>&1 && \
L
liuyq-617 已提交
72
        ( grep -q 'script.*'$case'.*failed.*, err.*lineNum' ../../sim/tsim/log/taoslog0.0 && echo -e "${RED} failed${NC}" | tee -a out.log  ||  echo -e "${GREEN} success${NC}" | tee -a out.log )|| \
L
liuyq-617 已提交
73 74 75
        ( grep -q 'script.*success.*m$' ../../sim/tsim/log/taoslog0.0 && echo -e "${GREEN} success${NC}" | tee -a out.log )  || \
        echo -e "${RED} failed${NC}" | tee -a out.log
      fi
L
liuyq-617 已提交
76
      out_log=`tail -1 out.log  `
L
liuyq-617 已提交
77 78 79
      # if [[ $out_log =~ 'failed' ]];then
      #   exit 8
      # fi
S
Shuduo Sang 已提交
80 81
      end_time=`date +%s`
      echo execution time of $case was `expr $end_time - $start_time`s. | tee -a out.log
82 83 84
    fi
  done < $1
}
L
liuyq-617 已提交
85
function runSimCaseOneByOnefq {
L
liuyq-617 已提交
86 87 88 89 90

  start=`sed -n "/$1-start/=" jenkins/basic.txt`
  end=`sed -n "/$1-end/=" jenkins/basic.txt`  
  for ((i=$start;i<=$end;i++)) ; do
    line=`sed -n "$i"p jenkins/basic.txt`
L
liuyq-617 已提交
91 92 93
    if [[ $line =~ ^./test.sh* ]] || [[ $line =~ ^run* ]]; then
			case=`echo $line | grep sim$ |awk '{print $NF}'`

94
      start_time=`date +%s`    
P
Ping Xiao 已提交
95
      date +%F\ %T | tee -a out.log
96
      if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
L
liuyq-617 已提交
97
        echo -n $case
98
        ./test.sh -f $case > ../../../sim/case.log 2>&1 && \
L
liuyq-617 已提交
99
        ( grep -q 'script.*'$case'.*failed.*, err.*lineNum' ../../../sim/tsim/log/taoslog0.0 && echo -e "${RED} failed${NC}" | tee -a out.log  ||  echo -e "${GREEN} success${NC}" | tee -a out.log )|| \
L
liuyq-617 已提交
100
        ( grep -q 'script.*success.*m$' ../../../sim/tsim/log/taoslog0.0 && echo -e "${GREEN} success${NC}" | tee -a out.log )  || \
101
        ( echo -e "${RED} failed${NC}" | tee -a out.log && echo '=====================log=====================' && cat ../../../sim/case.log )
102
      else
L
liuyq-617 已提交
103
        echo -n $case
104
        ./test.sh -f $case > ../../sim/case.log 2>&1 && \
L
liuyq-617 已提交
105
        ( grep -q 'script.*'$case'.*failed.*, err.*lineNum' ../../sim/tsim/log/taoslog0.0 && echo -e "${RED} failed${NC}" | tee -a out.log  ||  echo -e "${GREEN} success${NC}" | tee -a out.log )|| \
L
liuyq-617 已提交
106
        ( grep -q 'script.*success.*m$' ../../sim/tsim/log/taoslog0.0 && echo -e "${GREEN} success${NC}" | tee -a out.log )  || \
107
        ( echo -e "${RED} failed${NC}" | tee -a out.log && echo '=====================log=====================' &&  cat ../../sim/case.log )
108 109
      fi
      
L
liuyq-617 已提交
110 111
      out_log=`tail -1 out.log  `
      if [[ $out_log =~ 'failed' ]];then
112
        if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
L
liuyq-617 已提交
113
          cp -r ../../../sim ~/sim_`date "+%Y_%m_%d_%H:%M:%S"`
114
          rm -rf ../../../sim/case.log
115
        else 
L
liuyq-617 已提交
116
          cp -r ../../sim ~/sim_`date "+%Y_%m_%d_%H:%M:%S" `
117
          rm -rf ../../sim/case.log
118
        fi
L
liuyq-617 已提交
119
        dohavecore $2 1
L
fix  
liuyq-617 已提交
120 121 122
        if [[ $2 == 1 ]];then
          exit 8
        fi
L
liuyq-617 已提交
123 124 125
      fi
      end_time=`date +%s`
      echo execution time of $case was `expr $end_time - $start_time`s. | tee -a out.log
L
liuyq-617 已提交
126
      dohavecore $2 1
L
liuyq-617 已提交
127
    fi
L
liuyq-617 已提交
128
  done 
129 130
  rm -rf ../../../sim/case.log
  rm -rf ../../sim/case.log
L
liuyq-617 已提交
131
}
132 133 134 135

function runPyCaseOneByOne {
  while read -r line; do
    if [[ $line =~ ^python.* ]]; then
136
      if [[ $line != *sleep* ]]; then
L
liuyq-617 已提交
137 138 139 140 141 142
        
        if [[ $line =~ '-r' ]];then
          case=`echo $line|awk '{print $4}'`
        else
          case=`echo $line|awk '{print $NF}'`
        fi
S
Shuduo Sang 已提交
143
        start_time=`date +%s`
P
Ping Xiao 已提交
144
        date +%F\ %T | tee -a pytest-out.log
L
liuyq-617 已提交
145
        echo -n $case
146
        $line > /dev/null 2>&1 && \
L
liuyq-617 已提交
147 148
          echo -e "${GREEN} success${NC}" | tee -a pytest-out.log || \
          echo -e "${RED} failed${NC}" | tee -a pytest-out.log
S
Shuduo Sang 已提交
149
        end_time=`date +%s`
L
liuyq-617 已提交
150
        out_log=`tail -1 pytest-out.log  `
L
liuyq-617 已提交
151 152 153
        # if [[ $out_log =~ 'failed' ]];then
        #   exit 8
        # fi
S
Shuduo Sang 已提交
154
        echo execution time of $case was `expr $end_time - $start_time`s. | tee -a pytest-out.log
155 156 157
      else
        $line > /dev/null 2>&1
      fi
158 159 160
    fi
  done < $1
}
L
liuyq-617 已提交
161 162 163 164 165 166 167 168 169 170 171
function runPyCaseOneByOnefq() {
  cd $tests_dir/pytest
  if [[ $1 =~ full ]] ; then
    start=1
    end=`sed -n '$=' fulltest.sh`
  else
    start=`sed -n "/$1-start/=" fulltest.sh`
    end=`sed -n "/$1-end/=" fulltest.sh`
  fi
  for ((i=$start;i<=$end;i++)) ; do
    line=`sed -n "$i"p fulltest.sh`
L
liuyq-617 已提交
172 173 174 175 176 177 178 179 180
    if [[ $line =~ ^python.* ]]; then
      if [[ $line != *sleep* ]]; then
        
        if [[ $line =~ '-r' ]];then
          case=`echo $line|awk '{print $4}'`
        else
          case=`echo $line|awk '{print $NF}'`
        fi
        start_time=`date +%s`
P
Ping Xiao 已提交
181
        date +%F\ %T | tee -a pytest-out.log
L
liuyq-617 已提交
182
        echo -n $case
183
        $line > ../../sim/case.log 2>&1 && \
L
liuyq-617 已提交
184
          echo -e "${GREEN} success${NC}" | tee -a pytest-out.log || \
185
          echo -e "${RED} failed${NC}" | tee -a pytest-out.log 
L
liuyq-617 已提交
186 187 188
        end_time=`date +%s`
        out_log=`tail -1 pytest-out.log  `
        if [[ $out_log =~ 'failed' ]];then
L
liuyq-617 已提交
189
          cp -r ../../sim ~/sim_`date "+%Y_%m_%d_%H:%M:%S" `
L
fix  
liuyq-617 已提交
190
          echo '=====================log===================== '
191 192
          cat ../../sim/case.log
          rm -rf ../../sim/case.log
L
liuyq-617 已提交
193
          dohavecore $2 2
L
fix  
liuyq-617 已提交
194 195 196
          if [[ $2 == 1 ]];then
            exit 8
          fi
L
liuyq-617 已提交
197 198 199 200 201
        fi
        echo execution time of $case was `expr $end_time - $start_time`s. | tee -a pytest-out.log
      else
        $line > /dev/null 2>&1
      fi
L
liuyq-617 已提交
202
      dohavecore $2 2
L
liuyq-617 已提交
203
    fi
L
liuyq-617 已提交
204
  done 
205
  rm -rf ../../sim/case.log
L
liuyq-617 已提交
206
}
207

208 209
totalFailed=0
totalPyFailed=0
210
totalJDBCFailed=0
P
Ping Xiao 已提交
211
totalUnitFailed=0
212
totalExampleFailed=0
sangshuduo's avatar
sangshuduo 已提交
213

L
liuyq-617 已提交
214
corepath=`grep -oP '.*(?=core_)' /proc/sys/kernel/core_pattern||grep -oP '.*(?=core-)' /proc/sys/kernel/core_pattern`
215
if [ "$2" != "jdbc" ] && [ "$2" != "python" ] && [ "$2" != "unit" ]  && [ "$2" != "example" ]; then
216
  echo "### run TSIM test case ###"
S
Shuduo Sang 已提交
217
  cd $tests_dir/script
218

219 220 221 222 223 224
  [ -f out.log ] && rm -f out.log
  if [ "$1" == "cron" ]; then
    echo "### run TSIM regression test ###"
    runSimCaseOneByOne regressionSuite.sim
  elif [ "$1" == "full" ]; then
    echo "### run TSIM full test ###"
P
Ping Xiao 已提交
225
    runSimCaseOneByOne jenkins/basic.txt
L
liuyq-617 已提交
226 227
  elif [ "$1" == "b1" ]; then
    echo "### run TSIM b1 test ###"
L
liuyq-617 已提交
228 229 230
    runSimCaseOneByOnefq b1 0
    runSimCaseOneByOnefq b4 0
    runSimCaseOneByOnefq b7 0
L
liuyq-617 已提交
231 232
  elif [ "$1" == "b2" ]; then
    echo "### run TSIM b2 test ###"
L
liuyq-617 已提交
233
    runSimCaseOneByOnefq b2 0
L
balance  
liuyq-617 已提交
234
    runSimCaseOneByOnefq b5 0
L
liuyq-617 已提交
235 236
  elif [ "$1" == "b3" ]; then
    echo "### run TSIM b3 test ###"
L
liuyq-617 已提交
237
    runSimCaseOneByOnefq b3 0
L
balance  
liuyq-617 已提交
238
    runSimCaseOneByOnefq b6 0
L
liuyq-617 已提交
239 240
  elif [ "$1" == "b1fq" ]; then
    echo "### run TSIM b1 test ###"
L
liuyq-617 已提交
241
    runSimCaseOneByOnefq b1 1
L
liuyq-617 已提交
242 243
  elif [ "$1" == "b2fq" ]; then
    echo "### run TSIM b2 test ###"
L
liuyq-617 已提交
244
    runSimCaseOneByOnefq b2 1
L
liuyq-617 已提交
245 246
  elif [ "$1" == "b3fq" ]; then
    echo "### run TSIM b3 test ###"
L
liuyq-617 已提交
247
    runSimCaseOneByOnefq b3 1
L
liuyq-617 已提交
248 249
  elif [ "$1" == "b4fq" ]; then
    echo "### run TSIM b4 test ###"
L
liuyq-617 已提交
250
    runSimCaseOneByOnefq b4 1
L
liuyq-617 已提交
251 252
  elif [ "$1" == "b5fq" ]; then
    echo "### run TSIM b5 test ###"
L
liuyq-617 已提交
253
    runSimCaseOneByOnefq b5 1
L
liuyq-617 已提交
254 255
  elif [ "$1" == "b6fq" ]; then
    echo "### run TSIM b6 test ###"
L
liuyq-617 已提交
256
    runSimCaseOneByOnefq b6 1
L
liuyq-617 已提交
257 258
  elif [ "$1" == "b7fq" ]; then
    echo "### run TSIM b7 test ###"
L
liuyq-617 已提交
259
    runSimCaseOneByOnefq b7 1
S
Shuduo Sang 已提交
260
  elif [ "$1" == "smoke" ] || [ -z "$1" ]; then
261 262 263
    echo "### run TSIM smoke test ###"
    runSimCaseOneByOne basicSuite.sim
  fi
264

265 266
  totalSuccess=`grep 'success' out.log | wc -l`
  totalBasic=`grep success out.log | grep Suite | wc -l`
267

268 269 270
  if [ "$totalSuccess" -gt "0" ]; then
    totalSuccess=`expr $totalSuccess - $totalBasic`
  fi
sangshuduo's avatar
sangshuduo 已提交
271

S
Shuduo Sang 已提交
272
  echo -e "\n${GREEN} ### Total $totalSuccess TSIM case(s) succeed! ### ${NC}"
273

274 275
  totalFailed=`grep 'failed\|fault' out.log | wc -l`
# echo -e "${RED} ### Total $totalFailed TSIM case(s) failed! ### ${NC}"
276

277
  if [ "$totalFailed" -ne "0" ]; then
S
Shuduo Sang 已提交
278
    echo -e "\n${RED} ### Total $totalFailed TSIM case(s) failed! ### ${NC}"
sangshuduo's avatar
sangshuduo 已提交
279

280 281
#  exit $totalFailed
  fi
sangshuduo's avatar
sangshuduo 已提交
282 283
fi

284
if [ "$2" != "sim" ] && [ "$2" != "jdbc" ] && [ "$2" != "unit" ]  && [ "$2" != "example" ]; then
285
  echo "### run Python test case ###"
286

S
Shuduo Sang 已提交
287
  cd $tests_dir
288

S
Shuduo Sang 已提交
289
  if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
290 291 292 293 294 295 296 297 298 299 300 301 302 303 304
    cd ../..
  else
    cd ../
  fi

  TOP_DIR=`pwd`
  TAOSLIB_DIR=`find . -name "libtaos.so"|grep -w lib|head -n1`
  if [[ "$TAOSLIB_DIR" == *"$IN_TDINTERNAL"* ]]; then
    LIB_DIR=`find . -name "libtaos.so"|grep -w lib|head -n1|cut -d '/' --fields=2,3,4,5`
  else
    LIB_DIR=`find . -name "libtaos.so"|grep -w lib|head -n1|cut -d '/' --fields=2,3,4`
  fi

  export LD_LIBRARY_PATH=$TOP_DIR/$LIB_DIR:$LD_LIBRARY_PATH

S
Shuduo Sang 已提交
305
  cd $tests_dir/pytest
306 307 308 309 310 311 312 313 314

  [ -f pytest-out.log ] && rm -f pytest-out.log

  if [ "$1" == "cron" ]; then
    echo "### run Python regression test ###"
    runPyCaseOneByOne regressiontest.sh
  elif [ "$1" == "full" ]; then
    echo "### run Python full test ###"
    runPyCaseOneByOne fulltest.sh
L
liuyq-617 已提交
315
  elif [ "$1" == "pytest" ]; then
L
liuyq-617 已提交
316 317
    echo "### run Python full test ###"
    runPyCaseOneByOne fulltest.sh
L
liuyq-617 已提交
318 319
  elif [ "$1" == "pytestfq" ]; then
    echo "### run Python full test ###"
L
liuyq-617 已提交
320
    runPyCaseOneByOnefq full 0
321 322
  elif [ "$1" == "p1" ]; then
    echo "### run Python_1 test ###"
L
liuyq-617 已提交
323
    runPyCaseOneByOnefq p1 1
324 325
  elif [ "$1" == "p2" ]; then
    echo "### run Python_2 test ###"
L
liuyq-617 已提交
326
    runPyCaseOneByOnefq p2 1
L
liuyq-617 已提交
327 328
  elif [ "$1" == "p3" ]; then
    echo "### run Python_3 test ###"
L
liuyq-617 已提交
329
    runPyCaseOneByOnefq p3 1 
L
liuyq-617 已提交
330 331
  elif [ "$1" == "p4" ]; then
    echo "### run Python_4 test ###"
L
liuyq-617 已提交
332
    runPyCaseOneByOnefq p4 1
L
liuyq-617 已提交
333 334
  elif [ "$1" == "b2" ] || [ "$1" == "b3" ]; then
    exit $(($totalFailed + $totalPyFailed))
S
Shuduo Sang 已提交
335
  elif [ "$1" == "smoke" ] || [ -z "$1" ]; then
336 337 338
    echo "### run Python smoke test ###"
    runPyCaseOneByOne smoketest.sh
  fi
339
  totalPySuccess=`grep 'success' pytest-out.log | wc -l`
340 341

  if [ "$totalPySuccess" -gt "0" ]; then
S
Shuduo Sang 已提交
342
    echo -e "\n${GREEN} ### Total $totalPySuccess python case(s) succeed! ### ${NC}"
343 344 345 346
  fi

  totalPyFailed=`grep 'failed\|fault' pytest-out.log | wc -l`
  if [ "$totalPyFailed" -ne "0" ]; then
S
Shuduo Sang 已提交
347
    echo -e "\n${RED} ### Total $totalPyFailed python case(s) failed! ### ${NC}"
348
#  exit $totalPyFailed
349
  fi
sangshuduo's avatar
sangshuduo 已提交
350 351
fi

352

353
if [ "$2" != "sim" ] && [ "$2" != "python" ] && [ "$2" != "unit" ]  && [ "$2" != "example" ] && [ "$1" == "full" ]; then
354
  echo "### run JDBC test cases ###"
355

P
Ping Xiao 已提交
356
  cd $tests_dir
357 358 359 360 361 362 363

  if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
    cd ../../
  else
    cd ../
  fi

P
Ping Xiao 已提交
364
  pwd
365
  cd debug/
P
change  
Ping Xiao 已提交
366
  
P
Ping Xiao 已提交
367
  stopTaosd
368
  rm -rf /var/lib/taos/*
369 370
  nohup build/bin/taosd -c /etc/taos/ > /dev/null 2>&1 &
  sleep 30
P
change  
Ping Xiao 已提交
371
  
372
  cd $tests_dir/../src/connector/jdbc  
P
Ping Xiao 已提交
373
  
P
change  
Ping Xiao 已提交
374
  mvn test > jdbc-out.log 2>&1
375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396
  tail -n 20 jdbc-out.log

  cases=`grep 'Tests run' jdbc-out.log | awk 'END{print $3}'`
  totalJDBCCases=`echo ${cases/%,}`
  failed=`grep 'Tests run' jdbc-out.log | awk 'END{print $5}'`
  JDBCFailed=`echo ${failed/%,}`
  error=`grep 'Tests run' jdbc-out.log | awk 'END{print $7}'`
  JDBCError=`echo ${error/%,}`
  
  totalJDBCFailed=`expr $JDBCFailed + $JDBCError`
  totalJDBCSuccess=`expr $totalJDBCCases - $totalJDBCFailed`

  if [ "$totalJDBCSuccess" -gt "0" ]; then
    echo -e "\n${GREEN} ### Total $totalJDBCSuccess JDBC case(s) succeed! ### ${NC}"
  fi
  
  if [ "$totalJDBCFailed" -ne "0" ]; then
    echo -e "\n${RED} ### Total $totalJDBCFailed JDBC case(s) failed! ### ${NC}"
  fi
  dohavecore 1
fi

397
if [ "$2" != "sim" ] && [ "$2" != "python" ] && [ "$2" != "jdbc" ]  && [ "$2" != "example" ]  && [ "$1" == "full" ]; then
398 399 400 401 402 403 404 405 406 407 408 409 410
  echo "### run Unit tests ###"  

  stopTaosd
  cd $tests_dir

  if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
    cd ../../
  else
    cd ../
  fi

  pwd
  cd debug/build/bin
411
  rm -rf /var/lib/taos/*
412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432
  nohup ./taosd -c /etc/taos/ > /dev/null 2>&1 &
  sleep 30
  
  pwd
  ./queryTest > unittest-out.log 2>&1
  tail -n 20 unittest-out.log

  totalUnitTests=`grep "Running" unittest-out.log | awk '{print $3}'`  
  totalUnitSuccess=`grep 'PASSED' unittest-out.log | awk '{print $4}'`
  totalUnitFailed=`expr $totalUnitTests - $totalUnitSuccess`

  if [ "$totalUnitSuccess" -gt "0" ]; then
    echo -e "\n${GREEN} ### Total $totalUnitSuccess Unit test succeed! ### ${NC}"
  fi
  
  if [ "$totalUnitFailed" -ne "0" ]; then
    echo -e "\n${RED} ### Total $totalUnitFailed Unit test failed! ### ${NC}"
  fi
  dohavecore 1
fi

433 434
if [ "$2" != "sim" ] && [ "$2" != "python" ] && [ "$2" != "jdbc" ] && [ "$2" != "unit" ] && [ "$1" == "full" ]; then
  echo "### run Example tests ###"  
435

436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459 460 461 462
  stopTaosd
  cd $tests_dir

  if [[ "$tests_dir" == *"$IN_TDINTERNAL"* ]]; then
    cd ../../
  else
    cd ../
  fi

  pwd
  cd debug/build/bin
  rm -rf /var/lib/taos/*
  nohup ./taosd -c /etc/taos/ > /dev/null 2>&1 &
  echo "sleeping for 30 seconds"
  #sleep 30
  
  cd $tests_dir
  echo "current dir: "
  pwd
  cd examples/c
  echo "building applications"
  make > /dev/null
  totalExamplePass=0

  echo "Running tests"
  ./apitest > /dev/null 2>&1
  if [ $? != "0" ]; then
P
Ping Xiao 已提交
463
    echo "apitest failed"
464 465
    totalExampleFailed=`expr $totalExampleFailed + 1`    
  else
P
Ping Xiao 已提交
466
    echo "apitest pass"
467 468 469 470 471 472 473 474 475 476 477 478 479 480
    totalExamplePass=`expr $totalExamplePass + 1`
  fi 

  ./prepare 127.0.0.1 > /dev/null 2>&1
  if [ $? != "0" ]; then
    echo "prepare failed"
    totalExampleFailed=`expr $totalExampleFailed + 1`    
  else
    echo "prepare pass"
    totalExamplePass=`expr $totalExamplePass + 1`
  fi

  ./subscribe -test > /dev/null 2>&1
  if [ $? != "0" ]; then
P
Ping Xiao 已提交
481
    echo "subscribe failed"
482 483
    totalExampleFailed=`expr $totalExampleFailed + 1`    
  else
P
Ping Xiao 已提交
484
    echo "subscribe pass"
485 486 487 488 489
    totalExamplePass=`expr $totalExamplePass + 1`
  fi

  yes |./asyncdemo 127.0.0.1 test 1000 10 > /dev/null 2>&1
  if [ $? != "0" ]; then
P
Ping Xiao 已提交
490
    echo "asyncdemo failed"
491 492
    totalExampleFailed=`expr $totalExampleFailed + 1`    
  else
P
Ping Xiao 已提交
493
    echo "asyncdemo pass"
494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509
    totalExamplePass=`expr $totalExamplePass + 1`
  fi
  
  if [ "$totalExamplePass" -gt "0" ]; then
    echo -e "\n${GREEN} ### Total $totalExamplePass examples succeed! ### ${NC}"
  fi
  
  if [ "$totalExampleFailed" -ne "0" ]; then
    echo -e "\n${RED} ### Total $totalExampleFailed examples failed! ### ${NC}"
  fi

  dohavecore 1
fi


exit $(($totalFailed + $totalPyFailed + $totalJDBCFailed + $totalUnitFailed + $totalExampleFailed))